"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataDepot = void 0;
const Errors = __importStar(require("./Errors"));
const Reader_1 = require("./Reader");
const Writer_1 = require("./Writer");
class DataDepot {
    constructor() {
        throw new Errors.InstantiateStaticClassError("DataDepot");
    }
}
exports.DataDepot = DataDepot;
DataDepot.load = (depot, basePath, chunkName, key) => {
    depot.load(new Reader_1.ChunkReader(basePath, chunkName).read(key));
};
DataDepot.loadFromJson = (depot, filePath, encoding) => {
    depot.load(new Reader_1.JsonReader(filePath, encoding).read());
};
DataDepot.loadFromObject = (depot, object) => {
    depot.load(new Reader_1.ObjectReader(object).read());
};
DataDepot.insertAnObject = (depot, key, object) => {
    depot.setItem(key, new Reader_1.ObjectReader(object).read());
};
DataDepot.write = (depot, basePath, option) => {
    const serialized = (option === null || option === void 0 ? void 0 : option.key) !== undefined
        ? depot._serialize(option.key)
        : depot._serialize();
    if (option) {
        const { chunkName, maxChunkSize, maxChunkCount } = option;
        new Writer_1.ChunkWriter(basePath, {
            chunkName,
            maxChunkSize,
            maxChunkCount,
        }).write(serialized);
    }
    else {
        new Writer_1.ChunkWriter(basePath).write(serialized);
    }
};
DataDepot.writeToJson = (depot, fileName) => {
    new Writer_1.JsonWriter(fileName).write(depot._serialize());
};
//# sourceMappingURL=DataDepot.js.map